﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;
using Xamarin.Forms.Labs.Controls;
using Xamarin.Forms.Labs.ServiceStackSerializer;

namespace HybridSample
{
    public class App
    {
        
        public static Page GetMainPage()
        {


            return new HybridPage
            {
                Padding = new Thickness(0, Device.OnPlatform(20, 0, 0), 0, 0),
            };
        }
    }

    public class HybridPage : ContentPage
    {
        private readonly HybridWebView hybrid;

        public HybridPage()
        {

            var stack = new StackLayout()
                {
                    VerticalOptions = LayoutOptions.FillAndExpand,
                    HorizontalOptions = LayoutOptions.FillAndExpand
                };

            stack.Children.Add(new Label() { Text = "Type below to change text in HTML" });

            var entry = new Entry()
                {
                    HorizontalOptions = LayoutOptions.FillAndExpand
                };

            this.hybrid = new HybridWebView(new JsonSerializer())
                {
                    VerticalOptions = LayoutOptions.FillAndExpand,
                    HorizontalOptions = LayoutOptions.FillAndExpand
                };
                        
            stack.Children.Add(entry);
            stack.Children.Add(this.hybrid);

            entry.TextChanged += (s, e) => 
                hybrid.CallJsFunction("assignFromCSharp", entry.Text);

            hybrid.RegisterCallback("sendToCSharp", 
                text => 
                entry.Text = text);

            this.Content = stack;
        }

        protected override void OnAppearing()
        {
            base.OnAppearing();
            hybrid.LoadFromContent("twoway.html");

        }
    }
}
